<?php
require_once './lib/common.php';
initialize();
require_once 'HTML/QuickForm.php';

$db = initDatabase();

$filter = array(
	'id_article' => FILTER_VALIDATE_INT,
	'id_comment' => FILTER_VALIDATE_INT,
);
$param = (object) filter_input_array(INPUT_GET, $filter);
if (empty($param->id_article)) {
	$param = (object) filter_input_array(INPUT_POST, $filter);
	if (empty($param->id_article)) {
		// redirection (syntaxe incorrecte, il faut normalement une URL absolue)
		header('Location: article_list.php');
		exit();
	}
}

// pour un exemple de formulaire sans QuickForm, voir "user_login.php".
$form = new HTML_QuickForm('commentForm', 'post');
$form->setRequiredNote('<span style="color:red">*</span> Champ obligatoire');

$form->setDefaults(array( 'id_article', $param->id_article ));
if (!empty($param->id_comment)) {
	$form->setDefaults(
		$db
		->query("SELECT title, content FROM comment WHERE id = $param->id_comment")
		->fetchAll()
	);
}

$form->addElement('hidden', 'id_article', $param->id_article);
$form->addElement('hidden', 'id_comment', $param->id_comment);
$form->addElement('text', 'title', 'Titre :', array('size' => 60, 'maxlength' => 255));
$form->addRule('title', 'Ce champ est nécessaire', 'required', null, 'client');
$form->applyFilter('title', 'trim');
$form->addElement('textarea', 'content', 'Texte :', array('cols' => 60, 'rows' => 6));
$form->addRule('content', 'Ce champ est nécessaire', 'required', null, 'client');

$form->addElement('submit', null, 'Ajouter ce commentaire');

// Le formulaire a-t-il été correctement rempli ?
if ($form->validate()) {
	$values = (object) $form->exportValues();

	if (empty($values->id_comment)) {
		$sql = "INSERT INTO comment (id_article, title, content, id_user) "
			."VALUES (:id_article, :title, :content, :id_user)";
		$sth = $db->prepare($sql);
		$sth->bindParam(':id_article', $values->id_article, PDO::PARAM_INT);
	} else {
		$sql = "UPDATE comment SET title=:title, content=:content, id_user=:id_user"
			." WHERE id = :id_comment";
		$sth = $db->prepare($sql);
		$sth->bindParam(':id_comment', $values->id_comment, PDO::PARAM_INT);
	}
	$sth->bindParam(':title', $values->title, PDO::PARAM_STR);
	$sth->bindParam(':content', $values->content, PDO::PARAM_STR);
	$sth->bindParam(':id_user', $_SESSION['user']->id, PDO::PARAM_INT);
	if ($sth->execute()) {
		// redirection (syntaxe incorrecte, il faut normalement une URL complète)
		header('Location: article_view.php?id=' . $param->id_article);
		exit();
	} else {
		die("Erreur SQLite (permission d'écriture sur le fichier et son répertoire ?) : $sql");
	}
}


?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
<head>
        <title>Sécurité PHP - commentaire</title>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
</head>
<body>

<h1>Ajouter/modifier un commentaire</h1>
 <?php $form->display() ?>

<h1>Code source de cette page</h1>
<div style="border-left: 3px solid red; padding-left: 1em;">
<?php highlight_file(__FILE__); ?>
</div>

</body>
</html>
