<?php
require_once './lib/common.php';
initialize();
require_once 'HTML/QuickForm.php';

$form = new HTML_QuickForm('userForm', 'post');

$form->addElement('header', null, 'Formulaire d\'inscription');

$form->addElement('text', 'name', 'Votre nom :', array('size' => 50, 'maxlength' => 255));
// validation JS et PHP : http://pear.php.net/manual/en/package.html.html-quickform.intro-validation.php
$form->addRule('name', 'Merci d\'inscrire votre nom', 'required', null, 'client');
$form->applyFilter('name', 'trim');

$form->addElement('text', 'login', 'Login :', array('size' => 20, 'maxlength' => 20));
$form->addRule('name', 'Le login doit être formé uniquement de lettres.', 'lettersonly', null, 'client');
$form->addRule('login', 'Ce champ est nécessaire', 'required', null, 'client');

$form->addElement('password', 'password', 'Mot de passe :', array('size' => 20, 'maxlength' => 50));
$form->addRule('password', 'Ce champ est nécessaire', 'required', null, 'client');

$form->addElement('text', 'url', 'Votre site :', array('size' => 50, 'maxlength' => 255));
$form->addRule('url', 'L\'URL doit être valide', 'regex', '/^http:\/\/.+', 'client');

$form->addElement('submit', null, 'Créer ce compte');

// Le formulaire a-t-il été correctement rempli ?
if ($form->validate()) {
	$db = initDatabase();
	$sth = $db->prepare("INSERT INTO user (name, login, password, url) VALUES (?, ?, ?, ?)");
	// les paramètres sont dans un tableau (presque) prêt à l'emploi !
	if ($sth->execute(array_values($form->exportValues()))) {
		// redirection (syntaxe incorrecte, il faut normalement une URL complète)
		header('Location: user_login.php');
		exit();
	} else {
		die("Erreur SQLite (p.e. chmod a+Xrw lib lib/database.sq3) : $sql");
	}
}

	
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
<head>
        <title>Sécurité PHP - création de compte</title>
</head>
<body>

<h1>Création de compte</h1>
<?php $form->display(); ?>

<p> <a href="article_list.php">Retour à la liste des articles</a> </p>

<h1>Code source de cette page</h1>
<div style="border-left: 3px solid red; padding-left: 1em;">
<?php highlight_file(__FILE__); ?>
</div>

</body>
</html>
