<?php
require_once './lib/common.php';
initialize();

$filter = array(
	'login' => array(
		'filter' => FILTER_VALIDATE_REGEXP,
		'options' => array( 'regexp' => '/^[a-z]+$/i' )
	),
	'password' => FILTER_UNSAFE_RAW,
);
$param = (object) filter_input_array(INPUT_POST, $filter);

if (!empty($param->login) && !empty($param->password)) {
	$db = initDatabase();
	// Les colonnes devraient être de type binary (pas de collation dans la comparaison)
	$sql = sprintf(
		"SELECT * FROM user WHERE login=%s AND password=%s",
		$db->quote($param->login),
		$db->quote($param->password)
	);
	$result = $db->query($sql);
	if (!$result) {
		die("Erreur SQL");
	}
	$users = $result->fetchAll(PDO::FETCH_OBJ);
	if (count($users) === 1) {
		$_SESSION['user'] = $users[0];
		$_SESSION['user']->id = (int) $_SESSION['user']->id;
		// redirection (syntaxe incorrecte, il faut normalement une URL complète)
		header('Location: article_list.php');
		exit();
	}
}
	
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
<head>
        <title>Sécurité PHP - login</title>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
</head>
<body>

<h1>Authentification et injection SQL</h1>
<form action="" method="post">
<fieldset>
        Login : <input name="login" type="text" value="<?php if (!empty($param->login)) { echo htmlspecialchars($param->login); } ?>" /> <br />
        Mot de passe : <input name="password" type="text" value="" /> <br />
        <button type="submit" name="ok" value="1">S'authentifier</button>
</fieldset>
</form>

<h1>Code source de cette page</h1>
<div style="border-left: 3px solid red; padding-left: 1em;">
<?php highlight_file(__FILE__); ?>
</div>

</body>
</html>
